!=====================================================================
! ͭѿνΥ⥸塼
! 2002/01/20
!=====================================================================
module common_variable
  use prm
  implicit none
  real(8) , save :: x(0:im-1)              ! x ɸ
  real(8) , save :: zk(0:km)               ! ƺɸ
  real(8) , save :: h_init(0:im-1)         ! ɹν
  real(8) , save :: T_init(0:im-1, 0:km)   ! ɹνʬ

  real(8) , save :: delta_zk_j(0:km-1)       ! j
  real(8) , save :: delta_zk_j1_2(0:km)  ! j+1/2
  real(8) , save :: Q
  real(8) , save :: A_0

  integer        :: i,j             ! do ѿ


contains

!=====================================================================
! ɹ
!=====================================================================
  subroutine get_h_init(h_init)
    real(8) , intent(out)  :: h_init(0:im-1)
    integer , parameter    :: x_s = 12               ! ɹ¦
    ! ͤ
    ! ɹ
    
    
    h_init(0:x_s-1) = hmax
    h_init(x_s:im-1) = 0. 

    !10 ǯ餻ɹͤȤ  
    !open(10, file='h-init2.dat')
    !read(10, *) h_init
    !close(10)


  end subroutine get_h_init


!=====================================================================
! ʬۤ
! ǮƳ
!=====================================================================
  subroutine get_T_init(T_init)
    real(8)  , intent(out)  :: T_init(0:im-1, 0:km)    ! ɹνʬ
!    integer                 :: i,j                     ! do ѿ

    do i = 0, im-1
       do j = 0, km
          T_init(i, j) = T_s + gamma /k_ice * h_init(i) * (1 - zk(j))  
       end do
    end do


  end subroutine get_T_init

!=====================================================================
! ٰ¸ѥ᡼ؿν
! 2002/01/26
!=====================================================================
  subroutine depend_T_prm(T, A_0, Q)
    real(8)  , intent(in)   :: T
    real(8)  , intent(out)  :: Q
    real(8)  , intent(out)  :: A_0

    if(T <= 263.15)then
       Q = 60.e3
       A_0 = 1.14e-5/s_a
    else
       Q = 139.e3
       A_0 = 5.47e-10/s_a
    end if
  end subroutine depend_T_prm

!=====================================================================
! ɸ
!=====================================================================
  subroutine get_frame(x, zk)
    real(8) , intent(out)  :: x(0:im-1)
    real(8) , intent(out)  :: zk(0:km)

    x  = (/(i, i=0, im-1)/) * dx

! 10 
    zk = (/0.0, 0.02, 0.05, 0.10, 0.17, 0.25,0.40, 0.55, 0.70, 0.85, 1.0/)  

! ֳgrid
!    zk = (/0.0D0, 0.1D0, 0.2D0, 0.3D0, 0.4D0, 0.5D0, 0.6D0, 0.7D0, 0.8D0, 0.9D0, 1.0D0/)  

! 20 
!    zk = (/0.0, 0.01, 0.02, 0.03, 0.05, 0.07, 0.10, 0.13, 0.17, 0.20, 0.25, &
!         & 0.32, 0.40, 0.47, 0.55, 0.63, 0.70, 0.77, 0.85, 0.93, 1.0/)
! 40 
!    zk = (/0.0, 0.005, 0.01, 0.015, 0.02, 0.025, 0.03, 0.04, 0.05, 0.06, &
!         & 0.07, 0.085, 0.10, 0.115, 0.13, 0.15, 0.17, 0.18, 0.20, 0.22, &
!         & 0.25, 0.28, 0.32, 0.36, 0.40, 0.43, 0.47, 0.52, 0.55, 0.58,  &
!         & 0.63, 0.67, 0.70, 0.73, 0.77, 0.80, 0.85, 0.89, 0.93, 0.96, 1.0/)
  end subroutine get_frame

!=====================================================================
! ƺɸ˴ؤѿã
! ʻҴֳ֤
!  2002/01/29
!=====================================================================

  subroutine get_zeta_hensu(delta_zk_j, delta_zk_j1_2)
    real(8) , intent(out)  :: delta_zk_j(0:km-1)     !j
    real(8) , intent(out)  :: delta_zk_j1_2(0:km)    !_{j+1/2}
    

    !  ʻҴֳ֤
    ! (岼Ǵֳ֤ȾʬˤʤäƤΤ 2 )
    delta_zk_j1_2(0) = 2.0D0*(zk(1) - zk(0))         + epsilon(0.0)
!    delta_zk_j1_2(0) = (zk(1) - zk(0))         
    delta_zk_j1_2(km) = 2.0D0*(zk(km) - zk(km-1)) + epsilon(0.0) 
!    delta_zk_j1_2(km) = (zk(km) - zk(km-1))
    

    delta_zk_j(0)   = zk(1) - zk(0) 
    
    do j = 1, km-1 
       delta_zk_j(j) = zk(j+1) - zk(j) 
                                                ! ʻǤγʻҴֳ
       delta_zk_j1_2(j) = (zk(j+1) - zk(j-1))/2.0D0 
                                                ! ȾʻǤγʻҴֳ
    end do




  end subroutine get_zeta_hensu
end module common_variable
